Default config file changes:

- do register Environment variables by default; for backwards-compat
- remove extension= example junk for Windows.
- set sendmail_path to the usual default
- set session.save_path to a secure default for execution via Apache.

Adapted for >= PHP 4.3.6-rc3 by Robert Scheck

--- php-4.3.6RC3/php.ini-recommended		2004-03-29 23:28:47.000000000 +0200
+++ php-4.3.6RC3/php.ini-recommended.config	2004-04-09 19:01:42.000000000 +0200
@@ -104,7 +104,7 @@
 ; setting this directive to On.  If you wish to limit the size of the buffer
 ; to a certain size - you can use a maximum number of bytes instead of 'On', as
 ; a value for this directive (e.g., output_buffering=4096).
-output_buffering = 4096
+output_buffering = Off
 
 ; You can redirect all of the output of your scripts to a function.  For
 ; example, if you set output_handler to "mb_output_handler", character
@@ -366,7 +366,7 @@
 ; Environment and Built-in variables (G, P, C, E & S respectively, often
 ; referred to as EGPCS or GPC).  Registration is done from left to right, newer
 ; values override older values.
-variables_order = "GPCS"
+variables_order = "EGPCS"
 
 ; Whether or not to register the EGPCS variables as global variables.  You may
 ; want to turn this off if you don't want to clutter your scripts' global scope
@@ -382,7 +382,7 @@
 ; This directive tells PHP whether to declare the argv&argc variables (that
 ; would contain the GET information).  If you don't use these variables, you
 ; should turn it off for increased performance.
-register_argc_argv = Off
+register_argc_argv = On
 
 ; Maximum size of POST data that PHP will accept.
 post_max_size = 8M
@@ -440,7 +440,7 @@
 user_dir =
 
 ; Directory in which the loadable extensions (modules) reside.
-extension_dir = "./"
+extension_dir = /usr/lib/php4
 
 ; Whether or not to enable the dl() function.  The dl() function does NOT work
 ; properly in multithreaded servers, such as IIS or Zeus, and is automatically
@@ -534,11 +534,7 @@
 ;
 ;   extension=modulename.extension
 ;
-; For example, on Windows:
-;
-;   extension=msql.dll
-;
-; ... or under UNIX:
+; For example:
 ;
 ;   extension=msql.so
 ;
@@ -547,53 +543,10 @@
 ; extension_dir directive above.
 
 
-;Windows Extensions
-;Note that MySQL and ODBC support is now built in, so no dll is needed for it.
-;
-;extension=php_bz2.dll
-;extension=php_cpdf.dll
-;extension=php_crack.dll
-;extension=php_curl.dll
-;extension=php_db.dll
-;extension=php_dba.dll
-;extension=php_dbase.dll
-;extension=php_dbx.dll
-;extension=php_domxml.dll
-;extension=php_exif.dll
-;extension=php_fdf.dll
-;extension=php_filepro.dll
-;extension=php_gd2.dll
-;extension=php_gettext.dll
-;extension=php_hyperwave.dll
-;extension=php_iconv.dll
-;extension=php_ifx.dll
-;extension=php_iisfunc.dll
-;extension=php_imap.dll
-;extension=php_interbase.dll
-;extension=php_java.dll
-;extension=php_ldap.dll
-;extension=php_mbstring.dll
-;extension=php_mcrypt.dll
-;extension=php_mhash.dll
-;extension=php_mime_magic.dll
-;extension=php_ming.dll
-;extension=php_mssql.dll
-;extension=php_msql.dll
-;extension=php_oci8.dll
-;extension=php_openssl.dll
-;extension=php_oracle.dll
-;extension=php_pdf.dll
-;extension=php_pgsql.dll
-;extension=php_printer.dll
-;extension=php_shmop.dll
-;extension=php_snmp.dll
-;extension=php_sockets.dll
-;extension=php_sybase_ct.dll
-;extension=php_w32api.dll
-;extension=php_xmlrpc.dll
-;extension=php_xslt.dll
-;extension=php_yaz.dll
-;extension=php_zip.dll
+;;;;
+; Note: packaged extension modules are now loaded via the .ini files
+; found in the directory /etc/php.d; these are loaded by default.
+;;;;
 
 
 ;;;;;;;;;;;;;;;;;;;
@@ -614,7 +567,7 @@
 ;sendmail_from = me@example.com
 
 ; For Unix only.  You may supply arguments as well (default: "sendmail -t -i").
-;sendmail_path =
+sendmail_path = /usr/sbin/sendmail -t -i
 
 [Java]
 ;java.class.path = .\php_java.jar
@@ -825,7 +778,7 @@
 ; Argument passed to save_handler.  In the case of files, this is the path
 ; where data files are stored. Note: Windows users have to change this 
 ; variable in order to use PHP's session functions.
-;session.save_path = /tmp
+session.save_path = /var/lib/php/session
 
 ; Whether to use cookies.
 session.use_cookies = 1